import pythoncom
from win32com.server.exception import COMException
import win32com.server.util
import win32com.client.dynamic
import win32gui
import random
import pandas as pd
import numpy as np
from pykalman import KalmanFilter
from pykalman import UnscentedKalmanFilter


class PythonUtilities(object):
    _public_methods_=['KALMAN','UKALMAN']	

    #
    # Use pythoncom.CreateGuid() 2/1/08
    #               
    _reg_clsid_="{25F32489-9E84-4D9F-8AEB-44EC9B528499}"
    _reg_desc_ =   "Kalman Filter Amibroker AFL"
    _reg_progid_ = "PyKalman"
    _readonly_attrs_ = ['revision']

   # class attributes can be defined and used to transfer values from AFL

    _public_attrs_=['NDepVar','ArrayLen','ProbArray',
                    'X_Open','X_High','X_Low','X_Close',
                    'X_Volume','X_OI','Log']

    Log=""  # Log may be a  string use to pass text to AFL
    
    def KALMAN(self,InList):
        # example infinite impulse response filter from Amibroker docs
        #
        self.revision="version 1"
        #DataFrame Conversion
        df=pd.DataFrame.from_records({'Close': InList})
        kf = KalmanFilter(transition_matrices = [1],
                  observation_matrices = [1],
                  initial_state_mean = df['Close'].values[0],
                  initial_state_covariance = 1,
                  observation_covariance=1,
                  transition_covariance=.01)
        state_means,_ = kf.filter(df[['Close']].values)
        state_means = state_means.flatten()
        return state_means
		
    def UKALMAN(self,InList):
        self.revision="version 1"
        #DataFrame Conversion
        df=pd.DataFrame.from_records({'Close': InList})
        ukf = UnscentedKalmanFilter(lambda x, w: x + np.sin(w), lambda x, v: x + v, observation_covariance=0.1,initial_state_mean = df['Close'].values[0])
        ustate_means,_ = ukf.filter(df[['Close']].values)
        ustate_means = ustate_means.flatten()
        return ustate_means
 
    
        
if __name__=='__main__':
    print "Registering COM Server "
    import win32com.server.register
    win32com.server.register.UseCommandLine(PythonUtilities)

# uncomment out if you want to unregister com server 

##    from win32com.server.register import UnregisterServer
##    UnregisterServer(PythonUtilities._reg_clsid_)
##    print "Com server unregistered."    

#############################################End Python Code
####################################